unit Unit21;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Menus, ImgList, FWSysTrayInfo;

type
  TForm21 = class(TForm)
    ListView1: TListView;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    ImageList1: TImageList;
    procedure N1Click(Sender: TObject);
    procedure ListView1CustomDrawItem(Sender: TCustomListView; Item: TListItem;
      State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    SysTray: TFWSysTrayInfo;
  end;

var
  Form21: TForm21;

implementation

{$R *.dfm}

uses
  CommCtrl;

procedure TForm21.FormCreate(Sender: TObject);
begin
  SysTray := TFWSysTrayInfo.Create;
end;

procedure TForm21.FormDestroy(Sender: TObject);
begin
  SysTray.Free;
end;

procedure TForm21.FormShow(Sender: TObject);

  function GetStateString(const State: Integer): String;
  begin
    Result := '';
    if (State and TBSTATE_ENABLED) <> TBSTATE_ENABLED then
    begin
      Result := '';
      Exit;
    end;
    if (State and TBSTATE_HIDDEN) =
      TBSTATE_HIDDEN then Result := '';
  end;

var          
  I: Integer;
begin
  SysTray.UpdateInfo;
  ListView1.SmallImages := SysTray.ImageList;
  for I := 0 to SysTray.IconCount - 1 do
  begin
    with ListView1.Items.Add do
    begin
      Caption := GetStateString(SysTray.IconItem[I].dwState);
      ImageIndex := SysTray.IconItem[I].iImage;
      SubItems.Add(SysTray.IconItem[I].szTip);
      SubItems.Add(SysTray.IconItem[I].szAppPath);
    end;
  end;
end;

procedure TForm21.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin
  if Item.Caption = '' then
    Sender.Canvas.Brush.Color := RGB(255, 206, 255);
end;

procedure TForm21.N1Click(Sender: TObject);
begin
  SysTray.DeleteIco(ListView1.Selected.Index);
end;

end.
